import { CodeMirror6 } from 'https://testingcf.jsdelivr.net/npm/@bhsd/codemirror-mediawiki@2.1.8/dist/main.min.js';
(() => {
    var _a;
    mw.loader.load('https://testingcf.jsdelivr.net/npm/@bhsd/codemirror-mediawiki@2.1.8/mediawiki.min.css', 'text/css');
    const instances = new WeakMap();
    const getInstance = ($ele) => instances.get($ele[0]);
    $.valHooks['textarea'] = {
        get(elem) {
            const cm = instances.get(elem);
            return (cm === null || cm === void 0 ? void 0 : cm.visible) ? cm.view.state.doc.toString() : elem.value;
        },
        set(elem, value) {
            const cm = instances.get(elem);
            if (cm === null || cm === void 0 ? void 0 : cm.visible) {
                cm.setContent(value);
            }
            else {
                elem.value = value;
            }
        },
    };
    function getCaretPosition(option) {
        const { view: { state: { selection: { main } } } } = getInstance(this);
        return (option === null || option === void 0 ? void 0 : option.startAndEnd) ? [main.from, main.to] : main.head;
    }
    const textSelection = {
        getContents() {
            return getInstance(this).view.state.doc.toString();
        },
        setContents(content) {
            getInstance(this).setContent(content);
            return this;
        },
        getSelection() {
            const { view: { state } } = getInstance(this);
            return state.sliceDoc(state.selection.main.from, state.selection.main.to);
        },
        setSelection({ start, end }) {
            const { view } = getInstance(this);
            view.dispatch({
                selection: { anchor: start, head: end !== null && end !== void 0 ? end : start },
            });
            view.focus();
            return this;
        },
        replaceSelection(value) {
            const { view } = getInstance(this);
            view.dispatch(view.state.replaceSelection(value));
            return this;
        },
        getCaretPosition,
        scrollToCaretPosition() {
            getInstance(this).view.dispatch({ scrollIntoView: true });
            return this;
        },
    };
    const USING_LOCAL = mw.loader.getState('ext.CodeMirror') !== null, DATA_MODULE = mw.loader.getState('ext.CodeMirror.data') ? 'ext.CodeMirror.data' : 'ext.CodeMirror', ALL_SETTINGS_CACHE = (_a = JSON.parse(localStorage.getItem('InPageEditMwConfig'))) !== null && _a !== void 0 ? _a : {}, SITE_ID = `${mw.config.get('wgServerName')}${mw.config.get('wgScriptPath')}`, SITE_SETTINGS = ALL_SETTINGS_CACHE[SITE_ID], VALID = (SITE_SETTINGS === null || SITE_SETTINGS === void 0 ? void 0 : SITE_SETTINGS.time) > Date.now() - 86400 * 1000 * 30;
    const getConfig = (magicWords, rule, flip) => {
        const words = magicWords.filter(rule).filter(({ 'case-sensitive': i }) => i !== flip)
            .flatMap(({ aliases, name, 'case-sensitive': i }) => aliases.map(alias => ({
            alias: (i ? alias : alias.toLowerCase()).replace(/:$/u, ''),
            name,
        }))), obj = {};
        for (const { alias, name } of words) {
            obj[alias] = name;
        }
        return obj;
    };
    const getConfigPair = (magicWords, rule) => [true, false]
        .map(bool => getConfig(magicWords, rule, bool));
    const setConfig = (config) => {
        mw.config.set('extCodeMirrorConfig', config);
    };
    const getMwConfig = async () => {
        if (USING_LOCAL && !VALID) {
            await mw.loader.using(DATA_MODULE);
        }
        let config = mw.config.get('extCodeMirrorConfig');
        if (!config && VALID) {
            ({ config } = SITE_SETTINGS);
            setConfig(config);
        }
        const isIPE = config && Object.values(config.functionSynonyms[0]).includes(true);
        if ((config === null || config === void 0 ? void 0 : config.img) && config.variants && !isIPE) {
            return {
                ...config,
                nsid: mw.config.get('wgNamespaceIds'),
            };
        }
        const { query: { general: { variants }, magicwords, extensiontags, functionhooks, variables }, } = await new mw.Api().get({
            meta: 'siteinfo',
            siprop: [
                'general',
                'magicwords',
                ...config && !isIPE ? [] : ['extensiontags', 'functionhooks', 'variables'],
            ],
            formatversion: '2',
        });
        const others = new Set(['msg', 'raw', 'msgnw', 'subst', 'safesubst']);
        if (config && !isIPE) {
            const { functionSynonyms: [insensitive] } = config;
            if (!('subst' in insensitive)) {
                Object.assign(insensitive, getConfig(magicwords, ({ name }) => others.has(name)));
            }
        }
        else {
            config = {
                tagModes: {
                    tab: 'text/mediawiki',
                    indicator: 'text/mediawiki',
                    poem: 'text/mediawiki',
                    ref: 'text/mediawiki',
                    option: 'text/mediawiki',
                    combooption: 'text/mediawiki',
                    tabs: 'text/mediawiki',
                    poll: 'text/mediawiki',
                    gallery: 'text/mediawiki',
                },
                tags: {},
                urlProtocols: mw.config.get('wgUrlProtocols'),
            };
            for (const tag of extensiontags) {
                config.tags[tag.slice(1, -1)] = true;
            }
            const functions = new Set([
                ...functionhooks,
                ...variables,
                ...others,
            ]);
            config.functionSynonyms = getConfigPair(magicwords, ({ name }) => functions.has(name));
            config.doubleUnderscore = getConfigPair(magicwords, ({ aliases }) => aliases.some(alias => /^__.+__$/u.test(alias)));
        }
        config.img = getConfig(magicwords, ({ name }) => name.startsWith('img_'));
        config.variants = variants ? variants.map(({ code }) => code) : [];
        config.nsid = mw.config.get('wgNamespaceIds');
        setConfig(config);
        ALL_SETTINGS_CACHE[SITE_ID] = { config: config, time: Date.now() };
        localStorage.setItem('InPageEditMwConfig', JSON.stringify(ALL_SETTINGS_CACHE));
        return config;
    };
    const linters = {};
    class CodeMirror extends CodeMirror6 {
        constructor(textarea, lang, config) {
            super(textarea, lang, config);
            instances.set(textarea, this);
            if (mw.loader.getState('jquery.textSelection') === 'ready') {
                $(textarea).data('jquery.textSelection', textSelection);
            }
            mw.hook('wiki-codemirror6').fire(this);
        }
        toggle(show = !this.visible) {
            super.toggle(show);
            $(this.textarea).data('jquery.textSelection', show && textSelection);
        }
        async getLinter(opt) {
            const linter = await super.getLinter(opt);
            linters[this.lang] = linter;
            return linter;
        }
        async defaultLint(on, opt) {
            if (!on) {
                this.lint();
                return;
            }
            const { lang } = this;
            if (!(lang in linters)) {
                await this.getLinter(opt);
                if (lang === 'mediawiki') {
                    const mwConfig = await getMwConfig(), config = {
                        ...await wikiparse.getConfig(),
                        ext: Object.keys(mwConfig.tags),
                        namespaces: mw.config.get('wgFormattedNamespaces'),
                        nsid: mwConfig.nsid,
                        doubleUnderscore: mwConfig.doubleUnderscore.map(obj => Object.keys(obj).map(s => s.slice(2, -2))),
                        variants: mwConfig.variants,
                        protocol: mwConfig.urlProtocols.replace(/\\:/gu, ':'),
                    };
                    [config.parserFunction[0]] = mwConfig.functionSynonyms;
                    if (!USING_LOCAL) {
                        for (const [key, val] of Object.entries(mwConfig.functionSynonyms[0])) {
                            if (!key.startsWith('#')) {
                                config.parserFunction[0][`#${key}`] = val;
                            }
                        }
                    }
                    config.parserFunction[1] = [
                        ...Object.keys(mwConfig.functionSynonyms[1]),
                        '=',
                    ];
                    for (const key of Object.keys(mwConfig.img)) {
                        config.img[key] = mwConfig.img[key].slice(4);
                    }
                    wikiparse.setConfig(config);
                }
            }
            else if (opt) {
                await this.getLinter(opt);
            }
            if (linters[lang]) {
                this.lint(linters[lang]);
            }
        }
        static async fromTextArea(textarea, lang) {
            const isWiki = lang === 'mediawiki' || lang === 'html', cm = new CodeMirror(textarea, isWiki ? undefined : lang);
            if (isWiki) {
                const config = await getMwConfig();
                cm.setLanguage(lang, config);
            }
            return cm;
        }
    }
    document.body.addEventListener('click', e => {
        if (e.target instanceof HTMLTextAreaElement && e.shiftKey && !instances.has(e.target)) {
            e.preventDefault();
            (async () => {
                var _a;
                const { wgAction, wgNamespaceNumber, wgPageContentModel } = mw.config.get();
                let lang;
                if (wgAction !== 'edit' && wgAction !== 'submit') {
                    await mw.loader.using('oojs-ui-windows');
                    lang = (_a = (await OO.ui.prompt('Language:') || undefined)) === null || _a === void 0 ? void 0 : _a.toLowerCase();
                }
                else {
                    switch (wgPageContentModel) {
                        case 'css':
                        case 'sanitized-css':
                            lang = 'css';
                            break;
                        case 'javascript':
                            lang = 'javascript';
                            break;
                        case 'json':
                            lang = 'json';
                            break;
                        case 'Scribunto':
                            lang = 'lua';
                            break;
                        case 'wikitext':
                            lang = wgNamespaceNumber === 274 ? 'html' : 'mediawiki';
                            break;
                    }
                }
                const cm = await CodeMirror.fromTextArea(e.target, lang);
                let opt;
                if (lang === 'mediawiki' && wgNamespaceNumber === 10) {
                    opt = { include: true };
                }
                else if (lang === 'javascript' && (wgNamespaceNumber === 8 || wgNamespaceNumber === 2300)) {
                    opt = {
                        env: { browser: true, es6: true },
                        parserOptions: { ecmaVersion: 6 },
                    };
                }
                await cm.defaultLint(true, opt);
            })();
        }
    });
    Object.assign(window, { CodeMirror6: CodeMirror });
})();
